using static System.Console;

await foreach (int liczba in PobierzLiczbyAsync())
{
  WriteLine($"Liczba: {liczba}");
}

async static IAsyncEnumerable<int> PobierzLiczbyAsync()
{
  Random r = new();

  // symulowanie pracy
  await Task.Delay(r.Next(1500, 3000));
  yield return r.Next(0, 1001);

  await Task.Delay(r.Next(1500, 3000));
  yield return r.Next(0, 1001);

  await Task.Delay(r.Next(1500, 3000));
  yield return r.Next(0, 1001);
}
